# The Multiplex Nature of Global Financial Contagions
## R. Maria del Rio-Chanona, Yevgeniya Korniyenko, Manasa Patnam and Mason A. Porter

## Data
The Coordinated Direct Investments Survey (CDIS) and Coordinated Portfolio Investment Survey CPIS are publicly available data sets. The references for these data are
* International Monetary Fund: Coordinated direct investment survey (2018). Available
at https://data.imf.org/?sk=40313609-F037-48C1-84B1-E1F1CE54D6D5
* International Monetary Fund: Coordinated portfolio investment survey (2018).
Available at https://data.imf.org/?sk=B981B4E3-4E58-467E-9B90-9DE0C3367363

In this repository we make available cleaned version of these data as edgelists. If you use these data please use the following references
* del Rio-Chanona, R.M., Korniyenko, Y., Patnam, M.,Porter, M.A.: The Multiplex Nature of Global Financial
Contagions (2020)
* Korniyenko, Y., Patnam, M., del Rio-Chanona, R.M., Porter, M.A.: Evolution of the
global financial network and contagion: A new approach. Tech. rep., International Monetary Fund (2018).

We obtained the Bank for International Settlements (BIS) data under confidentiality agreements with the BIS and cannot make it publicly available. 
The edgelist provided in this repository for banking layer corresponds to a complete network and not to the BIS.

* We also make available the Capital to Asset Ratio used for horizontal thresholds

## Code and figures
We use python 3.7 and make available the code used for the study. This code can be used to analyze other multiplex networks.  

To run contagion dynamics and centrality measures use the script run_contagion_and_ranks.py and specify the year of analysis in line 18. 
Note that we have replaced the BIS layer with a complete network and thus running this script does not reproduce the results in folder "real_results_csv".

To reproduce the figures of the paper run the following scripts
plot_centrality_edbamx_and_systemic_June2020.py for Fig. 3
plot_centrality_layers_June2020.py for Fig. 4 (specify Multiplex or Aggregate in lines 22 and 23)
plot_systemic_June2020.py for Fig.5 and 5
plot_systemic_country_table_June2020.py for Fig. 7
