# -*- coding: utf-8 -*-
"""
Created on Fri Sep  6 14:53:33 2019

@author: RdelRioChanona
This script plot the centrality measures of a given files for a listed group
of countries
Does for equity, debt, bank, aggregate and multiplex network
"""
import numpy as np
import pandas as pd
from matplotlib import pyplot as plt
import matplotlib.gridspec as gridspec
import scipy.stats

## First define some local folder path
data_path = './data/'
csv_files_path = './data/csv_files'
export_path_csv = './results/csv_internship/'
export_path_fig = './results/fig_internship/'

file_name_mx = "mx_centrality_3lay"
#file_name_agg = "agg_centrality_3lay"
file_name_mono = "mono_centrality_3lay"
file_name_agg = file_name_mono
car_name = ""

year= 2018
df_mx = pd.read_csv(export_path_csv + file_name_mx + str(year) + ".csv")
#df_agg = pd.read_csv(export_path_csv + file_name_agg + str(year) + ".csv")
df_mono = pd.read_csv(export_path_csv + file_name_mono + str(year) + ".csv")
df_agg = df_mono


centrality_list_agg = ['PageRank agg']

centrality_list_mx = ['MultiRank PageRank']

name = "Katz"
export_fig_name = "Katzrank_mx_all_3lay.png"
export_fig_name_agg = "Katzrank_agg_all_3lay.svg"
name = "MultiRank PageRank"
name_agg = "PageRank"
name_agg = "PageRank debt"
export_fig_name = "MRPagerank_mx_all_3lay.png"
export_fig_name_agg = "PageRank_debt_all_3lay.svg"
#name = "Cascade"
#export_fig_name = "Cascade_mx_all_3lay.png"

fontsize_ticks = 30
fontsize_axis = 30
fontsize_title = 40
fontsize_legend = 30

df_mx = pd.read_csv(export_path_csv + file_name_mx + str(year) + ".csv")
df_mono = pd.read_csv(export_path_csv + file_name_mono + str(year) + ".csv")

dict_country_mxMR = dict(zip(df_mx['MultiRank PageRank'], \
                             df_mx['MultiRank PageRank score']))

dict_country_monoPR = dict(zip(df_mono['PageRank agg'], \
                             df_mono['PageRank agg score']))

set_mx = set(df_mx['MultiRank PageRank'])
set_mono = set(df_mono['PageRank agg'])
array_country_mxMR = np.zeros(len(dict_country_mxMR.keys()))
array_country_monoPR = np.zeros(len(dict_country_mxMR.keys()))
for i, country in enumerate(dict_country_mxMR.keys()):
    array_country_mxMR[i] = dict_country_mxMR[country]
    array_country_monoPR[i] = dict_country_monoPR[country]


scipy.stats.kendalltau(array_country_mxMR, array_country_monoPR)


f = plt.figure(figsize=(18,12))
f.subplots_adjust(hspace=0.2)
gs = gridspec.GridSpec(1, 1)
ax = plt.subplot(gs[0])
ax.spines['right'].set_visible(False)
ax.spines['top'].set_visible(False)
ax.tick_params(labelsize=fontsize_ticks)
plt.scatter(array_country_monoPR, array_country_mxMR, s=200, alpha=0.8)
plt.yscale("log")
plt.xscale("log")
plt.ylim([0.001, 0.25])
plt.xlim([0.001, 0.25])
plt.ylabel("MultiRank", fontsize=fontsize_axis)
plt.xlabel("PageRank", fontsize=fontsize_axis)
plt.savefig(export_path_fig + car_name + "correlation.png", \
            bbox_inches="tight")
plt.show()

# =============================================================================
# Take correlations
# =============================================================================

for year in range(2008,2019):
    df_mx = pd.read_csv(export_path_csv + file_name_mx + str(year) + ".csv")
    df_mono = pd.read_csv(export_path_csv + file_name_mono + str(year) + ".csv")

    dict_country_mxMR = dict(zip(df_mx['MultiRank PageRank'], \
                                 df_mx['MultiRank PageRank score']))

    dict_country_monoPR = dict(zip(df_mono['PageRank agg'], \
                                 df_mono['PageRank agg score']))

    set_mx = set(df_mx['MultiRank PageRank'])
    set_mono = set(df_mono['PageRank agg'])
    array_country_mxMR = np.zeros(len(dict_country_mxMR.keys()))
    array_country_monoPR = np.zeros(len(dict_country_mxMR.keys()))
    for i, country in enumerate(dict_country_mxMR.keys()):
        if country not in ["United States", "United Kingdom", "Luxembourg", "Netherlands"]:
            array_country_mxMR[i] = dict_country_mxMR[country]
            array_country_monoPR[i] = dict_country_monoPR[country]

    tau, p = scipy.stats.kendalltau(array_country_mxMR, array_country_monoPR)
    print(year , "&" , round(tau, 2) , "&" , p)
    # spearman, p = scipy.stats.spearmanr(array_country_mxMR, array_country_monoPR)
    # print(year , "&" , round(spearman, 2) , "&" , p)
